import { renderless, api } from "@dftvue2-opentiny/vue-renderless/input/vue";
import { defineComponent, props, setup as _setup } from "@dftvue2-opentiny/vue-common";
import TinyTallStorage from "./tall-storage";
import { IconClose, IconError, IconEyeopen, IconEyeclose } from "@dftvue2-opentiny/vue-icon";
import Tooltip from "@dftvue2-opentiny/vue-tooltip";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  inheritAttrs: false,
  emits: ["update:modelValue", "change", "clear", "focus", "blur", "keyup", "keydown", "paste", "mouseenter", "mouseleave", "click"],
  components: {
    IconClose: IconClose(),
    IconError: IconError(),
    IconEyeopen: IconEyeopen(),
    IconEyeclose: IconEyeclose(),
    TinyTallStorage,
    TinyTooltip: Tooltip
  },
  props: [].concat(props, ["name", "size", "form", "type", "label", "modelValue", "height", "resize", "counter", "autosize", "disabled", "readonly", "tabindex", "clearable", "suffixIcon", "prefixIcon", "autocomplete", "showPassword", "validateEvent", "showWordLimit", "inputClass", "displayOnly", "displayOnlyContent"]),
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: _vm.m("relative text-xs", _vm.type !== "textarea" || _vm.slots.prepend || _vm.slots.append ? "inline-table" : "", _vm.type !== "textarea" ? "w-full" : "w-max align-bottom", _vm.slots.prepend || _vm.slots.append ? "leading-normal border-separate border-spacing-0" : "", _vm.$attrs.class),
    style: _vm.$attrs.style,
    attrs: {
      "data-tag": "tiny-input"
    },
    on: {
      "mouseenter": function mouseenter($event) {
        _vm.state.hovering = true;
        _vm.$emit("mouseenter", $event);
      },
      "mouseleave": function mouseleave($event) {
        _vm.state.hovering = false;
        _vm.$emit("mouseleave", $event);
      },
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, [_vm.type !== "textarea" ? [_vm.slots.prepend && !_vm.state.isDisplayOnly ? _c("div", {
    ref: "prepend",
    staticClass: "border-r-0 rounded-tr-none rounded-br-none bg-color-bg-2 text-color-text-placeholder border border-solid border-color-border rounded px-3 py-0 w-px align-middle table-cell relative whitespace-nowrap"
  }, [_vm._t("prepend")], 2) : _vm._e(), _c("span", {
    staticClass: "relative"
  }, [_vm.state.isDisplayOnly ? _c("tiny-tooltip", {
    attrs: {
      "effect": "light",
      "content": _vm.state.displayOnlyTooltip,
      "display": _vm.type === "password",
      "placement": "top"
    },
    nativeOn: {
      "mouseenter": function mouseenter($event) {
        return _vm.handleEnterDisplayOnlyContent.apply(null, arguments);
      }
    }
  }, [_vm.type === "password" ? _c("span", {
    staticClass: "absolute top-0 left-0 max-w-full overflow-hidden text-ellipsis whitespace-nowrap"
  }, [_vm._v(_vm._s(_vm.state.hiddenPassword))]) : _c("span", {
    staticClass: "absolute top-0 left-0 max-w-full overflow-hidden text-ellipsis whitespace-nowrap"
  }, [_vm._v(_vm._s(_vm.displayOnlyContent || _vm.state.nativeInputValue))])]) : _vm._e(), _vm.type !== "textarea" ? _c("input", _vm._b({
    ref: "input",
    class: _vm.m("w-full border-0 px-3 sm:border-solid sm:border-color-border sm:hover:border-color-border-hover sm:focus:border-color-brand-focus sm:disabled:border-color-border placeholder:text-color-text-placeholder placeholder:text-sm text-sm sm:placeholder:text-xs sm:text-xs text-color-text-primary bg-white disabled:cursor-not-allowed disabled:text-color-text-disabled disabled:bg-color-bg-2 h-7 leading-7 py-0 outline-0 transition-colors duration-200 ease-in-out ", _vm.slots.prepend || _vm.slots.append ? "align-middle table-cell" : "inline-block", _vm.slots.prepend && _vm.slots.append ? "rounded-none" : _vm.slots.prepend ? "rounded-tl-none rounded-bl-none rounded-tr rounded-br" : _vm.slots.append ? "rounded-tl rounded-bl rounded-tr-none rounded-br-none" : "rounded-sm", _vm.readonly ? "sm:border-0 text-ellipsis overflow-hidden whitespace-nowrap" : "sm:border", (_vm.slots.prefix || _vm.prefixIcon) && (_vm.slots.suffix || _vm.suffixIcon || _vm.clearable || _vm.showPassword) ? "pl-6 pr-6" : _vm.slots.prefix || _vm.prefixIcon ? "pl-6 pr-3" : _vm.slots.suffix || _vm.suffixIcon || _vm.clearable || _vm.showPassword ? "pl-3 pr-6" : "", _vm.state.isDisplayOnly ? "invisible h-auto leading-none border-0" : "", _vm.inputClass),
    attrs: {
      "name": _vm.name,
      "tabindex": _vm.tabindex,
      "type": _vm.showPassword ? _vm.state.passwordVisible ? "text" : "password" : _vm.type,
      "disabled": _vm.state.inputDisabled,
      "readonly": _vm.readonly,
      "unselectable": _vm.readonly ? "on" : "off",
      "autocomplete": _vm.autocomplete,
      "aria-label": _vm.label
    },
    on: {
      "compositionstart": _vm.handleCompositionStart,
      "compositionupdate": _vm.handleCompositionUpdate,
      "compositionend": _vm.handleCompositionEnd,
      "input": _vm.handleInput,
      "focus": _vm.handleFocus,
      "blur": _vm.handleBlur,
      "change": _vm.handleChange,
      "keyup": function keyup($event) {
        return _vm.$emit("keyup", $event);
      },
      "keydown": function keydown($event) {
        return _vm.$emit("keydown", $event);
      },
      "paste": function paste($event) {
        return _vm.$emit("paste", $event);
      }
    }
  }, "input", _vm.a(_vm.$attrs, ["type", "class", "style", "^onw+"]), false)) : _vm._e()], 1), _vm.isMemoryStorage ? _c("tiny-tall-storage", {
    attrs: {
      "name": _vm.name,
      "localstorage-data": _vm.storageData,
      "is-memory-storage": _vm.isMemoryStorage
    },
    on: {
      "selected": _vm.selectedMemory
    }
  }) : _vm._e(), (_vm.slots.prefix || _vm.prefixIcon) && !_vm.state.isDisplayOnly ? _c("span", {
    ref: "prefix",
    staticClass: "left-2 transition-all duration-300 ease-in-out text-xs absolute top-1/2 -translate-y-1/2 text-center text-color-text-placeholder flex items-center"
  }, [_vm._t("prefix"), _vm.prefixIcon ? _c(_vm.prefixIcon, {
    tag: "component",
    staticClass: "leading-7 text-center transition-all duration-300 ease-in-out text-xs"
  }) : _vm._e()], 2) : _vm._e(), !_vm.state.isDisplayOnly && _vm.getSuffixVisible() ? _c("span", {
    ref: "suffix",
    staticClass: "right-2 transition-all duration-300 ease-in-out pointer-events-none text-xs absolute top-1/2 -translate-y-1/2 text-center text-color-text-placeholder flex items-center"
  }, [_c("span", {
    staticClass: "pointer-events-auto text-xs flex justify-start items-center"
  }, [!_vm.state.showClear || !_vm.state.showPwdVisible || !_vm.state.isWordLimitVisible ? [_vm._t("suffix"), _vm.suffixIcon ? _c(_vm.suffixIcon, {
    tag: "component",
    staticClass: "leading-7 text-center transition-all duration-300 ease-in-out text-xs"
  }) : _vm._e()] : _vm._e(), _vm.state.showClear ? _c("icon-error", {
    staticClass: "leading-7 text-center transition-all duration-300 ease-in-out text-xs cursor-pointer fill-color-none-hover block sm:hidden",
    on: {
      "mousedown": function mousedown($event) {
        $event.preventDefault();
      },
      "click": _vm.clear
    }
  }) : _vm._e(), _vm.state.showClear ? _c("icon-close", {
    staticClass: "hidden sm:block leading-7 text-center transition-all duration-300 ease-in-out text-xs cursor-pointer",
    on: {
      "mousedown": function mousedown($event) {
        $event.preventDefault();
      },
      "click": _vm.clear
    }
  }) : _vm._e(), _vm.showPassword ? _c(_vm.state.passwordVisible ? "icon-eyeopen" : "icon-eyeclose", {
    tag: "component",
    staticClass: "leading-7 text-center transition-all duration-300 ease-in-out text-xs",
    nativeOn: {
      "click": function click($event) {
        return _vm.handlePasswordVisible.apply(null, arguments);
      }
    }
  }) : _vm._e(), _vm.state.isWordLimitVisible ? _c("span", {
    staticClass: "h-full inline-flex items-center text-xs text-color-text-placeholder"
  }, [_c("span", {
    staticClass: "bg-white leading-none inline-block"
  }, [_vm._v(_vm._s(_vm.state.showWordLimit ? _vm.state.textLength + "/" + _vm.state.upperLimit : _vm.state.textLength))])]) : _vm._e()], 2), _vm.state.validateState ? _c("i", {
    class: _vm.m("leading-7 text-center transition-all duration-300 ease-in-out text-xs pointer-events-none", _vm.state.validateIcon)
  }) : _vm._e()]) : _vm._e(), _vm.slots.append && !_vm.state.isDisplayOnly ? _c("div", {
    ref: "append",
    staticClass: "border-l-0 rounded-tl-none rounded-bl-none bg-color-bg-2 text-color-text-placeholder border border-solid border-color-border rounded-tr rounded-br px-3 py-0 w-px align-middle table-cell relative whitespace-nowrap"
  }, [_vm._t("append")], 2) : _vm._e(), _vm.slots.panel && !_vm.state.isDisplayOnly ? _c("div", {
    ref: "panel"
  }, [_vm._t("panel")], 2) : _vm._e()] : _c("span", [_vm.state.isDisplayOnly ? _c("tiny-tooltip", {
    attrs: {
      "effect": "light",
      "content": _vm.state.displayOnlyTooltip,
      "placement": "top"
    },
    nativeOn: {
      "mouseenter": function mouseenter($event) {
        return _vm.handleEnterDisplayOnlyContent.apply(null, arguments);
      }
    }
  }, [_c("span", {
    staticClass: "max-w-full text-ellipsis break-words line-clamp-5"
  }, [_vm._v(_vm._s(_vm.displayOnlyContent || _vm.state.nativeInputValue))])]) : _vm._e(), _c("textarea", _vm._b({
    ref: "textarea",
    staticClass: "block w-full border-0 sm:border-solid sm:border-color-border sm:hover:border-color-border-hover sm:focus:border-color-brand-focus sm:disabled:border-color-border outline-0 rounded placeholder:text-color-text-placeholder placeholder:text-xs text-xs text-color-text-primary bg-white disabled:cursor-not-allowed disabled:text-color-text-disabled disabled:bg-color-bg-2 leading-normal",
    class: [_vm.readonly ? "sm:border-0 px-0 py-0" : "sm:border px-3 py-2", _vm.state.isDisplayOnly ? "hidden" : ""],
    style: _vm.state.textareaStyle,
    attrs: {
      "tabindex": _vm.tabindex,
      "disabled": _vm.state.inputDisabled,
      "readonly": _vm.readonly,
      "unselectable": _vm.readonly ? "on" : "off",
      "autocomplete": _vm.autocomplete,
      "aria-label": _vm.label
    },
    on: {
      "compositionstart": _vm.handleCompositionStart,
      "compositionupdate": _vm.handleCompositionUpdate,
      "compositionend": _vm.handleCompositionEnd,
      "input": _vm.handleInput,
      "focus": _vm.handleFocus,
      "blur": _vm.handleBlur,
      "change": _vm.handleChange
    }
  }, "textarea", _vm.a(_vm.$attrs, ["type", "class", "style", "^on[A-Z]"]), false))], 1), _vm.state.isWordLimitVisible && _vm.type === "textarea" ? _c("span", {
    staticClass: "bg-white text-color-text-placeholder text-xs absolute bottom-1 right-3"
  }, [_vm._v(_vm._s(_vm.state.showWordLimit ? _vm.state.textLength + "/" + _vm.state.upperLimit : _vm.state.textLength))]) : _vm._e(), _vm._t("default")], 2);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  mobileFirst as default
};
