import { renderless, api } from "@dftvue2-opentiny/vue-renderless/input/vue";
import { defineComponent, props, setup as _setup } from "@dftvue2-opentiny/vue-common";
import { iconOperationfaild, iconChevronRight, iconEyeopen } from "@dftvue2-opentiny/vue-icon";
import ActionSheet from "@dftvue2-opentiny/vue-action-sheet";
import "@dftvue2-opentiny/vue-theme-mobile/input/index.css";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  inheritAttrs: false,
  emits: ["update:modelValue", "change", "clear", "focus", "blur", "keyup", "keydown", "paste", "mouseenter", "mouseleave"],
  components: {
    IconOperationfaild: iconOperationfaild(),
    IconChevronRight: iconChevronRight(),
    IconEyeopen: iconEyeopen(),
    TinyActionSheet: ActionSheet
  },
  props: [].concat(props, ["name", "form", "selectMenu", "ellipsis", "contentStyle", "labelWidth", "mobileTips", "isSelect", "type", "label", "modelValue", "disabled", "readonly", "clearable", "maxlength", "suffixIcon", "prefixIcon", "autocomplete", "showPassword", "validateEvent", "showWordLimit", "showTitle", "textareaTitle", "counter", "autosize", "tabindex"]),
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: [_vm.type === "textarea" ? "tiny-mobile-textarea" : "tiny-mobile-input", _vm.state.inputSize ? "tiny-mobile-input-" + _vm.state.inputSize : "", {
      "is-disabled": _vm.state.inputDisabled,
      "is-exceed": _vm.state.inputExceed,
      "is-showtitle": _vm.showTitle && _vm.type === "textarea",
      "is-showcontent": _vm.slots.content && _vm.type === "textarea",
      "is-showlimit": _vm.state.isWordLimitVisible && _vm.type === "textarea",
      "tiny-mobile-input-group": _vm.slots.prepend || _vm.slots.append,
      "tiny-mobile-input-group-append": _vm.slots.append,
      "tiny-mobile-input-group-prepend": _vm.slots.prepend,
      "tiny-mobile-input-prefix": _vm.slots.prefix || _vm.prefixIcon,
      "tiny-mobile-input-suffix": _vm.slots.suffix || _vm.suffixIcon || _vm.clearable || _vm.showPassword
    }],
    on: {
      "mouseenter": function mouseenter($event) {
        _vm.state.hovering = true;
      },
      "mouseleave": function mouseleave($event) {
        _vm.state.hovering = false;
      }
    }
  }, [_vm.type !== "textarea" && _vm.type !== "form" ? [_vm.slots.prepend ? _c("div", {
    staticClass: "tiny-mobile-input-group__prepend"
  }, [_vm._t("prepend")], 2) : _vm._e(), _vm.type !== "textarea" ? _c("input", _vm._b({
    ref: "input",
    staticClass: "tiny-mobile-input__inner",
    attrs: {
      "name": _vm.name,
      "tabindex": _vm.tabindex,
      "type": _vm.showPassword ? _vm.state.passwordVisible ? "text" : "password" : _vm.type,
      "disabled": _vm.state.inputDisabled,
      "readonly": _vm.readonly,
      "autocomplete": _vm.autocomplete,
      "aria-label": _vm.label
    },
    on: {
      "compositionstart": _vm.handleCompositionStart,
      "compositionupdate": _vm.handleCompositionUpdate,
      "compositionend": _vm.handleCompositionEnd,
      "input": _vm.handleInput,
      "focus": _vm.handleFocus,
      "blur": _vm.handleBlur,
      "change": _vm.handleChange
    }
  }, "input", _vm.a(_vm.$attrs, ["size", "class", "style", "^onw+"]), false)) : _vm._e(), _vm.slots.prefix || _vm.prefixIcon ? _c("span", {
    staticClass: "tiny-mobile-input__prefix"
  }, [_vm._t("prefix"), _vm.prefixIcon ? _c(_vm.prefixIcon, {
    tag: "component",
    staticClass: "tiny-mobile-input__icon"
  }) : _vm._e()], 2) : _vm._e(), _vm.getSuffixVisible() ? _c("span", {
    staticClass: "tiny-mobile-input__suffix"
  }, [_c("span", {
    staticClass: "tiny-mobile-input__suffix-inner"
  }, [!_vm.state.showClear || !_vm.state.showPwdVisible || !_vm.state.isWordLimitVisible ? [_vm._t("suffix"), _vm.suffixIcon ? _c(_vm.suffixIcon, {
    tag: "component",
    staticClass: "tiny-mobile-input__icon"
  }) : _vm._e()] : _vm._e(), _vm.state.showClear ? _c("icon-operationfaild", {
    staticClass: "tiny-mobile-input__icon tiny-mobile-input__clear",
    on: {
      "mousedown": function mousedown($event) {
        $event.preventDefault();
      },
      "click": _vm.clear
    }
  }) : _vm._e(), _vm.state.showPwdVisible ? _c("icon-eyeopen", {
    staticClass: "tiny-mobile-input__icon",
    on: {
      "click": _vm.handlePasswordVisible
    }
  }) : _vm._e(), _vm.state.isWordLimitVisible ? _c("span", {
    staticClass: "tiny-mobile-input__count"
  }, [_c("span", {
    staticClass: "tiny-mobile-input__count-inner"
  }, [_vm._v(_vm._s(_vm.state.showWordLimit ? _vm.state.textLength + "/" + _vm.state.upperLimit : _vm.state.textLength))])]) : _vm._e()], 2), _vm.state.validateState ? _c("i", {
    staticClass: "tiny-mobile-input__icon",
    class: ["tiny-mobile-input__validateIcon", _vm.validateIcon]
  }) : _vm._e()]) : _vm._e(), _vm.slots.append ? _c("div", {
    staticClass: "tiny-mobile-input-group__append"
  }, [_vm._t("append")], 2) : _vm._e()] : _vm._e(), _vm.type === "form" ? [_c("div", {
    staticClass: "tiny-mobile-input-form"
  }, [_vm.isSelect ? _c("div", {
    staticClass: "tiny-mobile-input-form__select",
    on: {
      "click": _vm.showBox
    }
  }, [_c("input", _vm._b({
    staticClass: "tiny-mobile-input-form__input tiny-mobile-input__inner",
    attrs: {
      "type": "text",
      "disabled": _vm.state.inputDisabled,
      "name": _vm.name,
      "aria-label": _vm.label,
      "readonly": "",
      "tabindex": _vm.tabindex
    },
    domProps: {
      "value": _vm.state.checkedLable
    },
    on: {
      "input": _vm.handleInput,
      "change": _vm.handleChange
    }
  }, "input", _vm.a(_vm.$attrs, ["size", "class", "style", "^on[A-Z]"]), false)), _c("div", {
    staticClass: "tiny-mobile-input-form__icon",
    style: {
      transform: _vm.state.boxVisibility ? "rotate(90deg)" : "none"
    }
  }, [_c("IconChevronRight")], 1)]) : _c("input", _vm._b({
    ref: "input",
    staticClass: "tiny-mobile-input-form__input tiny-mobile-input__inner",
    attrs: {
      "type": _vm.showPassword ? _vm.state.passwordVisible ? "text" : "password" : "text",
      "name": _vm.name,
      "tabindex": _vm.tabindex,
      "disabled": _vm.state.inputDisabled,
      "readonly": _vm.readonly,
      "aria-label": _vm.label
    },
    on: {
      "compositionstart": _vm.handleCompositionStart,
      "compositionupdate": _vm.handleCompositionUpdate,
      "compositionend": _vm.handleCompositionEnd,
      "input": _vm.handleInput,
      "focus": _vm.handleFocus,
      "blur": _vm.handleBlur,
      "change": _vm.handleChange
    }
  }, "input", _vm.a(_vm.$attrs, ["size", "class", "style", "^on[A-Z]"]), false)), _c("tiny-action-sheet", {
    attrs: {
      "menus": _vm.selectMenu,
      "ellipsis": _vm.ellipsis,
      "contentStyle": _vm.contentStyle,
      "visible": _vm.state.boxVisibility
    },
    on: {
      "update:visible": function updateVisible($event) {
        _vm.state.boxVisibility = $event;
      }
    },
    model: {
      value: _vm.state.sheetvalue,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "sheetvalue", $$v);
      },
      expression: "state.sheetvalue"
    }
  })], 1), _vm.mobileTips ? _c("div", {
    staticClass: "tiny-mobile-input-form__tips"
  }, [_vm._v(" " + _vm._s(_vm.mobileTips) + " ")]) : _vm._e()] : _vm._e(), _vm.showTitle && _vm.type === "textarea" ? _c("div", {
    staticClass: "tiny-mobile-textarea__title"
  }, [_vm._v(" " + _vm._s(_vm.textareaTitle) + " ")]) : _vm._e(), _vm.slots.content && _vm.type === "textarea" ? _c("div", {
    staticClass: "tiny-mobile-textarea__content"
  }, [_vm._t("content")], 2) : _vm._e(), _vm.type === "textarea" ? _c("textarea", _vm._b({
    ref: "textarea",
    staticClass: "tiny-mobile-textarea__inner",
    style: _vm.state.textareaStyle,
    attrs: {
      "name": _vm.name,
      "tabindex": _vm.tabindex,
      "disabled": _vm.state.inputDisabled,
      "readonly": _vm.readonly,
      "autocomplete": _vm.autocomplete,
      "aria-label": _vm.label
    },
    on: {
      "compositionstart": _vm.handleCompositionStart,
      "compositionupdate": _vm.handleCompositionUpdate,
      "compositionend": _vm.handleCompositionEnd,
      "input": _vm.handleInput,
      "focus": _vm.handleFocus,
      "blur": _vm.handleBlur,
      "change": _vm.handleChange
    }
  }, "textarea", _vm.a(_vm.$attrs, ["type", "class", "style", "^on[A-Z]"]), false)) : _vm._e(), _vm.state.isWordLimitVisible && _vm.type === "textarea" ? _c("span", {
    staticClass: "tiny-mobile-textarea__count"
  }, [_vm._v(_vm._s(_vm.state.showWordLimit ? _vm.state.textLength + "/" + _vm.state.upperLimit : _vm.state.textLength))]) : _vm._e()], 2);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobile = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  mobile as default
};
