import { renderless, api } from "@dftvue2-opentiny/vue-renderless/input/vue";
import { defineComponent, props, setup as _setup } from "@dftvue2-opentiny/vue-common";
import TinyTallStorage from "./tall-storage";
import Tooltip from "@dftvue2-opentiny/vue-tooltip";
import { iconClose, iconEyeopen, iconEyeclose } from "@dftvue2-opentiny/vue-icon";
import "@dftvue2-opentiny/vue-theme/input/index.css";
import "@dftvue2-opentiny/vue-theme/textarea/index.css";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  emits: ["update:modelValue", "change", "clear", "focus", "blur", "keyup", "input", "keydown", "paste", "mouseenter", "mouseleave", "click"],
  components: {
    IconClose: iconClose(),
    IconEyeopen: iconEyeopen(),
    IconEyeclose: iconEyeclose(),
    TinyTallStorage,
    TinyTooltip: Tooltip
  },
  props: [].concat(props, ["name", "size", "form", "type", "label", "modelValue", "height", "resize", "counter", "autosize", "disabled", "readonly", "tabindex", "clearable", "suffixIcon", "prefixIcon", "autocomplete", "showPassword", "validateEvent", "showWordLimit", "displayOnly", "displayOnlyContent", "frontClearIcon"]),
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: [_vm.$attrs.class, _vm.type === "textarea" ? "tiny-textarea" : "tiny-input", _vm.state.inputSize ? "tiny-input-" + _vm.state.inputSize : "", {
      "is-disabled": _vm.state.inputDisabled,
      "is-exceed": _vm.state.inputExceed,
      "tiny-input-group": _vm.slots.prepend || _vm.slots.append,
      "tiny-input-group-append": _vm.slots.append,
      "tiny-input-group-prepend": _vm.slots.prepend,
      "tiny-input-prefix": _vm.slots.prefix || _vm.prefixIcon,
      "tiny-input-suffix": _vm.slots.suffix || _vm.suffixIcon || _vm.clearable || _vm.showPassword,
      "is-display-only": _vm.state.isDisplayOnly
    }],
    style: _vm.$attrs.style,
    on: {
      "mouseenter": function mouseenter($event) {
        _vm.state.hovering = true;
        _vm.$emit("mouseenter", $event);
      },
      "mouseleave": function mouseleave($event) {
        _vm.state.hovering = false;
        _vm.$emit("mouseleave", $event);
      },
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, [_vm.type !== "textarea" ? [_vm.slots.prepend ? _c("div", {
    staticClass: "tiny-input-group__prepend"
  }, [_vm._t("prepend")], 2) : _vm._e(), _c("span", {
    staticClass: "tiny-input-display-only"
  }, [_vm.state.isDisplayOnly ? _c("tiny-tooltip", {
    attrs: {
      "effect": "light",
      "content": _vm.state.displayOnlyTooltip,
      "display": _vm.type === "password",
      "placement": "top"
    },
    nativeOn: {
      "mouseenter": function mouseenter($event) {
        return _vm.handleEnterDisplayOnlyContent.apply(null, arguments);
      }
    }
  }, [_vm.type === "password" ? _c("span", {
    staticClass: "tiny-input-display-only__content"
  }, [_vm._v(_vm._s(_vm.state.hiddenPassword))]) : _c("span", {
    staticClass: "tiny-input-display-only__content"
  }, [_vm._v(_vm._s(_vm.displayOnlyContent || _vm.state.nativeInputValue))])]) : _vm._e(), _vm.type !== "textarea" ? _c("input", _vm._b({
    ref: "input",
    staticClass: "tiny-input__inner",
    attrs: {
      "name": _vm.name,
      "tabindex": _vm.tabindex,
      "type": _vm.showPassword ? _vm.state.passwordVisible ? "text" : "password" : _vm.type,
      "disabled": _vm.state.inputDisabled,
      "readonly": _vm.readonly,
      "unselectable": _vm.readonly ? "on" : "off",
      "autocomplete": _vm.autocomplete,
      "aria-label": _vm.label
    },
    on: {
      "compositionstart": _vm.handleCompositionStart,
      "compositionupdate": _vm.handleCompositionUpdate,
      "compositionend": _vm.handleCompositionEnd,
      "input": _vm.handleInput,
      "focus": _vm.handleFocus,
      "blur": _vm.handleBlur,
      "change": _vm.handleChange,
      "keyup": function keyup($event) {
        return _vm.$emit("keyup", $event);
      },
      "keydown": function keydown($event) {
        return _vm.$emit("keydown", $event);
      },
      "paste": function paste($event) {
        return _vm.$emit("paste", $event);
      }
    }
  }, "input", _vm.a(_vm.$attrs, ["type", "class", "style", "^onw+", "id"]), false)) : _vm._e()], 1), _vm.isMemoryStorage ? _c("tiny-tall-storage", {
    attrs: {
      "name": _vm.name,
      "localstorage-data": _vm.storageData,
      "is-memory-storage": _vm.isMemoryStorage
    },
    on: {
      "selected": _vm.selectedMemory
    }
  }) : _vm._e(), !_vm.state.isDisplayOnly && (_vm.slots.prefix || _vm.prefixIcon) ? _c("span", {
    ref: "prefix",
    staticClass: "tiny-input__prefix"
  }, [_vm._t("prefix"), _vm.prefixIcon ? _c(_vm.prefixIcon, {
    tag: "component",
    staticClass: "tiny-svg-size tiny-input__icon"
  }) : _vm._e()], 2) : _vm._e(), !_vm.state.isDisplayOnly && _vm.getSuffixVisible() ? _c("div", [_c("transition", {
    attrs: {
      "name": "tiny-transition-icon-out-in"
    }
  }, [_vm.getSuffixVisible() ? _c("span", {
    staticClass: "tiny-input__suffix"
  }, [_c("span", {
    staticClass: "tiny-input__suffix-inner"
  }, [_vm.frontClearIcon && _vm.state.showClear ? _c("icon-close", {
    staticClass: "tiny-svg-size tiny-input__icon tiny-input__clear",
    on: {
      "mousedown": function mousedown($event) {
        $event.preventDefault();
      },
      "click": _vm.clear
    }
  }) : _vm._e(), !_vm.state.showClear || !_vm.state.showPwdVisible || !_vm.state.isWordLimitVisible ? [_vm._t("suffix"), _vm.suffixIcon ? _c(_vm.suffixIcon, {
    tag: "component",
    staticClass: "tiny-svg-size tiny-input__icon"
  }) : _vm._e()] : _vm._e(), !_vm.frontClearIcon && _vm.state.showClear ? _c("icon-close", {
    staticClass: "tiny-svg-size tiny-input__icon tiny-input__clear",
    on: {
      "mousedown": function mousedown($event) {
        $event.preventDefault();
      },
      "click": _vm.clear
    }
  }) : _vm._e(), _vm.showPassword ? _c(_vm.state.passwordVisible ? "icon-eyeopen" : "icon-eyeclose", {
    tag: "component",
    staticClass: "tiny-svg-size tiny-input__icon",
    nativeOn: {
      "click": function click($event) {
        return _vm.handlePasswordVisible.apply(null, arguments);
      }
    }
  }) : _vm._e(), _vm.state.isWordLimitVisible ? _c("span", {
    staticClass: "tiny-input__count"
  }, [_c("span", {
    staticClass: "tiny-input__count-inner"
  }, [_c("span", {
    staticClass: "tiny-input__count-text-length"
  }, [_vm._v(" " + _vm._s(_vm.state.showWordLimit ? "" + _vm.state.textLength : "") + " ")]), _c("span", {
    staticClass: "tiny-input__count-upper-limit"
  }, [_vm._v(" " + _vm._s(_vm.state.showWordLimit ? "/" + _vm.state.upperLimit : _vm.state.textLength) + " ")])])]) : _vm._e()], 2), _vm.state.validateState ? _c("i", {
    staticClass: "tiny-input__icon",
    class: ["tiny-input__validateIcon", _vm.validateIcon]
  }) : _vm._e()]) : _vm._e()])], 1) : _vm._e(), _vm.slots.append ? _c("div", {
    staticClass: "tiny-input-group__append"
  }, [_vm._t("append")], 2) : _vm._e(), _vm.slots.panel ? _c("div", {
    staticClass: "tiny-input-group__panel"
  }, [_vm._t("panel")], 2) : _vm._e()] : _c("span", {
    class: [_vm.autosize ? "tiny-textarea-autosize-display-only" : "tiny-textarea-display-only"]
  }, [_vm.state.isDisplayOnly ? _c("tiny-tooltip", {
    attrs: {
      "effect": "light",
      "content": _vm.state.displayOnlyTooltip,
      "placement": "top"
    },
    nativeOn: {
      "mouseenter": function mouseenter($event) {
        return _vm.handleEnterDisplayOnlyContent($event, "textarea");
      }
    }
  }, [_c("span", {
    staticClass: "tiny-textarea-display-only__content"
  }, [_vm._v(_vm._s(_vm.displayOnlyContent || _vm.state.nativeInputValue))])]) : _vm._e(), _c("textarea", _vm._b({
    ref: "textarea",
    staticClass: "tiny-textarea__inner",
    style: _vm.state.textareaStyle,
    attrs: {
      "tabindex": _vm.tabindex,
      "disabled": _vm.state.inputDisabled,
      "readonly": _vm.readonly,
      "unselectable": _vm.readonly ? "on" : "off",
      "autocomplete": _vm.autocomplete,
      "aria-label": _vm.label
    },
    on: {
      "compositionstart": _vm.handleCompositionStart,
      "compositionupdate": _vm.handleCompositionUpdate,
      "compositionend": _vm.handleCompositionEnd,
      "input": _vm.handleInput,
      "focus": _vm.handleFocus,
      "blur": _vm.handleBlur,
      "change": _vm.handleChange
    }
  }, "textarea", _vm.a(_vm.$attrs, ["type", "class", "style", "id"]), false))], 1), _vm.state.isWordLimitVisible && _vm.type === "textarea" ? _c("span", {
    staticClass: "tiny-input__count"
  }, [_c("span", {
    staticClass: "tiny-input__count-inner"
  }, [_c("span", {
    staticClass: "tiny-input__count-text-length"
  }, [_vm._v(" " + _vm._s(_vm.state.showWordLimit ? "" + _vm.state.textLength : "") + " ")]), _c("span", {
    staticClass: "tiny-input__count-upper-limit"
  }, [_vm._v(" " + _vm._s(_vm.state.showWordLimit ? "/" + _vm.state.upperLimit : _vm.state.textLength) + " ")])])]) : _vm._e(), _vm._t("default")], 2);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  pc as default
};
